package com.jojubanking.boot.module.system.service.wqdaview;

import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;

import java.util.*;
import com.jojubanking.boot.module.system.controller.admin.wqdaview.vo.*;
import com.jojubanking.boot.module.system.dal.dataobject.wqdaview.WqdaViewDO;
import com.jojubanking.boot.framework.common.pojo.PageResult;

import com.jojubanking.boot.module.system.convert.wqdaview.WqdaViewConvert;
import com.jojubanking.boot.module.system.dal.mysql.wqdaview.WqdaViewMapper;

import static com.jojubanking.boot.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.jojubanking.boot.module.system.enums.ErrorCodeConstants.*;
import com.jojubanking.boot.module.system.dal.dataobject.wqdaview.WqdaViewCustDO;

/**
 * VIEW Service 实现类
 *
 * @author admin
 */
@Service
@Validated
public class WqdaViewServiceImpl implements WqdaViewService {

    @Resource
    private WqdaViewMapper wqdaViewMapper;

    @Override
    public Integer createWqdaView(WqdaViewCreateReqVO createReqVO) {
        // 插入
        WqdaViewDO wqdaView = WqdaViewConvert.INSTANCE.convert(createReqVO);
        wqdaViewMapper.insert(wqdaView);
        // 返回
        return wqdaView.getId();
    }

    @Override
    public void updateWqdaView(WqdaViewUpdateReqVO updateReqVO) {
        // 校验存在
        this.validateWqdaViewExists(updateReqVO.getId());
        // 更新
        WqdaViewDO updateObj = WqdaViewConvert.INSTANCE.convert(updateReqVO);
        wqdaViewMapper.updateById(updateObj);
    }

    @Override
    public void deleteWqdaView(Integer id) {
        // 校验存在
        this.validateWqdaViewExists(id);
        // 删除
        wqdaViewMapper.deleteById(id);
    }

    private void validateWqdaViewExists(Integer id) {
        if (wqdaViewMapper.selectById(id) == null) {
            throw exception(WQDA_VIEW_NOT_EXISTS);
        }
    }

    @Override
    public WqdaViewDO getWqdaView(Integer id) {
        return wqdaViewMapper.selectById(id);
    }

    @Override
    public List<WqdaViewDO> getWqdaViewList(Collection<Integer> ids) {
        return wqdaViewMapper.selectBatchIds(ids);
    }

    @Override
    public PageResult<WqdaViewDO> getWqdaViewPage(WqdaViewPageReqVO pageReqVO) {
        return wqdaViewMapper.selectPage(pageReqVO);
    }

    @Override
    public List<WqdaViewDO> getWqdaViewList(WqdaViewExportReqVO exportReqVO) {
        return wqdaViewMapper.selectList(exportReqVO);
    }

}
